include:
  - template: Workflows/MergeRequest-Pipelines.gitlab-ci.yml

image: registry.gitlab.com/geekstuff.dev/devcontainers/common/images/ci

default:
  retry: 2

stages:
  - main

services:
  - name: docker:27.1-dind
    alias: docker

variables:
  DOCKER_BUILDKIT: 1
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: tcp://docker:2375

before_script:
  - docker login
    -u $CI_REGISTRY_USER
    -p $CI_REGISTRY_PASSWORD
    $CI_REGISTRY

.docker:build-push:
  resource_group: busy
  script:
    - devcontainer build --workspace-folder . --image-name $CI_REGISTRY_IMAGE:$TAG
    - docker push $CI_REGISTRY_IMAGE:$TAG

.ctx:review:
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: never
    - when: on_success

.ctx:main:
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

.ctx:tag:
  rules:
    - if: $CI_COMMIT_TAG =~ /^v?[0-9]+[.][0-9]+([.][0-9]+)?$/

review:
  stage: main
  extends: [".ctx:review", ".docker:build-push"]
  variables:
    TAG: $CI_COMMIT_REF_SLUG

latest:
  stage: main
  extends: [".ctx:main", ".docker:build-push"]
  variables:
    TAG: latest

tag:
  stage: main
  extends: [".ctx:tag", ".docker:build-push"]
  variables:
    TAG: $CI_COMMIT_TAG
